<template>
    <tr>
        <td>{{ currency.name }}</td>
        <td>{{ currency.symbol }}</td>
        <td>{{ currency.code }}</td>
        <td>{{ currency.code_iso }}</td>
        <td>{{ currency.rate }}</td>
        <td>
            <form method="POST" :action="action" accept-charset="UTF-8">
                <input name="_method" type="hidden" value="DELETE">
                <input name="_token" type="hidden" :value="csrf_token">
                <div class="btn-group">
                    <a :href="action" class='btn btn-default btn-xs'><i class="far fa-eye"></i></a>
                    <a :href="action_edit" class='btn btn-default btn-xs'><i class="fas fa-edit"></i></a>
                    <button type="button" class="btn btn-default btn-xs" @click="update_rate"><i class="fas fa-sync" :class="updating_spin"></i></button>
                    <button type="submit" class="btn btn-danger btn-xs" onclick="return confirm('Are you sure?')"><i class="far fa-trash-alt"></i></button>
                </div>
            </form>
        </td>
    </tr>
</template>

<script>
	export default {
		props: ['model', 'base_url'],
        data(){
		    return {
		    	currency: this.model,
                updating_rate: false,
            }
        },
		watch: {
			model(newVal){
				this.currency = newVal;
			}
		},
        computed: {
			action: function(){
				return this.base_url+`/${this.currency.id}`
            },
			action_edit: function(){
				return this.action+`/edit`
            },
            csrf_token: () => window.csrf_token,
            updating_spin(){
				return {
					'fa-spin': this.updating_rate
				};
            }
        },
		methods: {
			update_rate(){
			    this.updating_rate = true;
				axios.post(`/api/currencies/${this.currency.id}/update_rate`)
					.then(({ data }) => {
						if(data.status === 'success'){
							this.currency = data.currency;
						}
					})
                    .finally(() => {
                    	this.updating_rate = false;
				    });
			}
		}
	}
</script>

<style scoped>

</style>
